/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef EDITTERM_WIN_CPP
#define EDITTERM_WIN_CPP

#include <wx/caret.h>
#include "scd_editterm.cpp"

// ============================================================================

class EditTerm_win : public wxScrolledWindow
{
private:
	wxCaret caret;
	wxTimer timer;
	wxMenu *popmenu;

public:
	SCD_EditTerm *editterm;

	EditTerm_win(wxWindow *parent);
	~EditTerm_win();

	void SetPopupMenu(wxMenu *mnu)
	{	popmenu = mnu;	}

	void OnKeyDown(wxKeyEvent& event)
	{	editterm->OnKeyDown(event);	}
	void OnChar(wxKeyEvent& event)
	{	editterm->OnChar(event);	}
	void OnMouseLeftDown(wxMouseEvent& event)
	{  	editterm->OnMouseLeftDown(event); 	}
	void OnMouseMotion(wxMouseEvent& event)
	{  	editterm->OnMouseMotion(event);	}
	void OnMouseLeftUp(wxMouseEvent& event)
	{
		editterm->OnMouseLeftUp(event);
		editterm->CopySelectionToClipboard(false);
	}
	void OnMouseRightDown(wxMouseEvent& event)
	{	if(popmenu)	PopupMenu( popmenu , event.GetX() , event.GetY() );	}
	void OnMouseMiddleDown(wxMouseEvent& event)
	{	editterm->PasteFromClipboard(true);	}

	void OnTimer(wxTimerEvent& event)
	{  	editterm->setBlinkCharVisibility( ! editterm->getBlinkCharVisibility() );	}

	void OnPaint(wxPaintEvent& event)
	{	editterm->OnPaint(event);	}


private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(EditTerm_win, wxScrolledWindow)
	EVT_PAINT(EditTerm_win::OnPaint)
	EVT_KEY_DOWN(EditTerm_win::OnKeyDown)
	EVT_CHAR(EditTerm_win::OnChar)
	EVT_LEFT_DOWN(EditTerm_win::OnMouseLeftDown)
	EVT_RIGHT_DOWN(EditTerm_win::OnMouseRightDown)
	EVT_MOTION(EditTerm_win::OnMouseMotion)
	EVT_LEFT_UP(EditTerm_win::OnMouseLeftUp)
	EVT_MIDDLE_DOWN(EditTerm_win::OnMouseMiddleDown)
	EVT_TIMER(0, EditTerm_win::OnTimer)
END_EVENT_TABLE()


EditTerm_win::EditTerm_win(wxWindow *parent) : wxScrolledWindow(parent, -1, wxDefaultPosition, wxDefaultSize, wxNO_FULL_REPAINT_ON_RESIZE)
{
	SetBackgroundColour(*wxBLACK);

	caret.Create(this, 8,2);
	this->SetCaret( &caret );
	caret.Show();

	this->SetFont( parent->GetFont() );

	editterm = new SCD_EditTerm(this);
	editterm->setScrolledWindow(this);
	editterm->SetOnLinkClickedFunc( OnLinkClicked );
    editterm->Show();

	wxSize cs = editterm->getCharSize();
    SetScrollRate( cs.GetWidth(), cs.GetHeight() );
    SetVirtualSize( editterm->getWindowSize() );

	//l timer
	timer.SetOwner(this, 0);
	timer.Start(600);
	
	popmenu = NULL;
}

EditTerm_win::~EditTerm_win()
{
	timer.Stop();
	if(editterm)	delete editterm;
}

// ============================================================================
#endif
